# KN MemoPad 機能追加版
Knatech 氏制作の SHARP Brain 用テキストエディタ **KN MemoPad** に、**文字色と背景色の変更機能**、 **UTF-8・UTF-16 LE・MS1252 文字コード及び CRLF・LF・CR 改行コードのサポート**、**行・列数表示機能**を追加したフォークです。既存機能はそのままですので、何かミスがなければ\*完全な上位互換として動作するはずです。

オリジナル版との干渉が起こることを防ぐため、設定の保存ファイルは別にしています。

オリジナル版は[ここ](https://bitbucket.org/knatech/brain-tools/src/master/)から入手できます。詳しい使い方も掲載されています。

\* Knatech 氏は独自DLLを用いて便利なダイアログなどの実装を行われていたため、私はMakefileの使えないeVC4で試行錯誤しながらlibの作成や本体プログラムのコンパイルを行った、という過程があります。また、文字コードのサポートを広げるためにファイル読み込み・保存の内部処理を大きく書き換えています。

# 動作要件
これは **Windows CE (ARMv4I)** 用ソフトウェアです。一部 SHARP Brain 専用の機能があります。

**SHARP Brain PW-SH1 (Windows Embedded CE 6.0, ARMv5TEJ)** で動作確認を行っています。

# 文字コード切り替えについて
BOMの情報だけを基に文字コードの自動判別を行います。BOM無しファイル(Shift_JIS/BOM無しUTF-8)の場合は、判別できませんので予め **Tools -> Charset...** で選択してから開いてください(先に開いてから選択し、Reloadでも構いません)。なお、この機能は **Tools -> Charset... -> Auto Detect by BOM** から無効化も可能です。

Reload及びSaveは、その時点で選択されている文字コードで行われます。予め開きたいor保存したい文字コードに設定してからそれらの処理を行ってください(間違った文字コードで処理してしまっても、設定し直してからやり直せば大丈夫です。)。

ちなみに、UTF-8 のBOM有り・無しは読み込み時に判別されます。

## 自動判別の仕様
- 最初が「EF BB BF」ならUTF-8、「FF FE」ならUTF-16 LEとして読み込む。
- 違ったら、BOM無しと判断し、現在ユーザが設定している文字コードを見る。UTF-16 LE以外ならそのまま、UTF-16 LEならShift_JISに設定する。

# 改行コード処理について
[wstring中の改行コードを変換する - わびさびサンプルソース](https://www.wabiapp.com/WabiSampleSource/windows/convert_crlf_w.html)で提供されているコードを基に、カスタマイズして使用しています。

どの改行コードでも指定不要で読み込める他、バグなどで改行コードが混在したファイルでも、正常に読み込むことができます。

読み込んだ時、最も多かった改行コード種をそのファイルの改行コードと判断し、**Tools -> Newline Code...** に設定します。保存前に別の改行コードに設定すれば、その改行コードで保存されます。

# 行・列数表示について
wordwrap が無効であれば正しく表示されますが、有効になっていると折り返しも1行とカウントされてしまいます。行・列数表示を参考にする場合は、 wordwrap を無効化することをお勧めします。

(思い返せば Windows 標準のメモ帳でも、Windows 10 で改良される前まで wordwrap 有効時はステータスバーが無効になっていた。)

# ソースコードについて
**src** 内にあります。プロジェクトは **eMbedded Visual C++ 4.0** のものです。

# 使用上の注意
**製作者は、このプログラムの利用によって生じた、いかなる損害についても責任を負いません。**

# 著作権情報など
オリジナル版が GNU General Public License v3.0 で配布されていますので、その規定に従い同じく **GNU General Public License v3.0** で配布します。

# 変更履歴
## v0.12 rev7 (2020/11/1)
改行コードCRLFで保存しようとすると、本文が空のデータが保存される問題を修正。

## v0.12 rev6 (2020/10/3)
ステータスバーの表示・非表示を切り替えられるようにした。

Reload 時は文字コード自動判別を行わないように変更した。

ステータスバーの行・列表示欄の幅が狭く、不足する場合があったのを修正。

ステータスバーがテキスト編集部分の上に被さってしまう問題を修正。

ウィンドウサイズが変化したとき、ステータスバーが適切に移動しない問題を修正。

その他、細かい修正や変更を行った。

## v0.12 rev5 (2020/9/30)
MS1252 (英語圏 Windows の ANSI) に対応した(海外のソフトのreadmeでたまに使われているので)。

現在指定されている改行コードと文字コードもステータスバーに表示するようにした。

Add BOM メニュー項目がうまく機能しなくなっていたのを修正。

## v0.12 rev4 (2020/9/30)
各改行コードに対応した。

現在キャレットがある行・列の番号を、ステータスバーに表示するようにした。

## v0.12 rev3 (2020/9/28)
BOMだけで判別する、簡単な文字コード自動判別を実装した。

## v0.12 rev2 (2020/9/23)
UTF-8(BOM有り無し両方) と UTF-16 LE に対応した。それに伴い、ファイル読み込み・保存の部分を大きく書き換えた。これによりオリジナル版の、ファイル末尾に勝手に改行が追加される仕様はなくなった。

色選択ダイアログ左下の、作成した色リストを保存するようにした。

バージョン情報を追加し、ソフトウェア内からも確認できるようにした。

コマンドラインや関連付けで指定されたファイルも開けるようにした。

## v0.12 rev1 (2020/9/20)
文字色・背景色を変更できる機能を追加した。